import java.util.Vector;

public class DWvStack extends M865Stack {
   public static final int initCap = 100;
   
   protected int top;
   protected Vector s;
   
   public DWvStack(int capacity, int increment) {
      top = 0;
      s = new Vector(capacity, increment);
   }
   
   public DWvStack(int capacity) {
      top = 0;
      s = new Vector(capacity);
   }
   
   public DWvStack() {
      this(initCap);
   }
   
   //  Push an object onto the stack.
   public void push(Object o) {
      s.add(top++, o);
   }
   
   //  Remove and return the object on the top of the stack.
   //  Return null if the stack is empty.
   public Object pop() {
      if (top == 0) {
         return null;
      } else {
         return s.remove(--top);
      }
   }
   
   //  Return true if the stack is empty, false otherwise.
   public boolean isEmpty() {
      return (top == 0);
   }
   
   //  Return the number of items in the stack.
   public int size() {
      return top;
   }
   
   //  Return the object on the top of the stack.
   public Object peek() {
      if (top == 0) {
         return null;
      } else {
         return s.get(top-1);
      }
   }
   
   //  Simple debugging routine
    public static void main(String args[]) {
       Integer myData;
       DWvStack myStack = new DWvStack();
       
       System.out.println("Stack empty: " + myStack.isEmpty());
       System.out.println("Stack size: " + myStack.size());
       for (int k=0; k<5; k++) {
          myData = new Integer(k);
          myStack.push(myData);
          System.out.println("Push: " + (Integer)myStack.peek());
       }
       System.out.println("Stack empty: " + myStack.isEmpty());
       System.out.println("Stack size: " + myStack.size());
       while ( !myStack.isEmpty() ) {
          System.out.println("Pop: " + (Integer)myStack.pop());
       }
       System.out.println("Stack empty: " + myStack.isEmpty());
       System.out.println("Stack size: " + myStack.size());
       myData = (Integer)myStack.pop();
       System.out.println("Pop: " + myData);
    }
   
}
