public class StackBenchmark {

   //  Simple debugging routine
    public static void main(String args[]) {
       
       Integer[] myData = new Integer[1000];
       //  Initialize the data objects
       for (int k=0; k<1000; k++) {
          myData[k] = new Integer(k);
          if (k % 100 == 0) {
             System.out.println("myData[ " + k + "] = " + myData[k]);          
          }
       }
  
       //  Create and initialize a stack of 1000 items.
       DWvStack aStack;
       System.out.println("Create a stack for 1000 items.");
       int maxLoops = 1000;
       long startTime = System.currentTimeMillis();
       for (int j=0; j<maxLoops; j++) {
          aStack = new DWvStack(1000);
       }
       long stopTime = System.currentTimeMillis();
       long elapsed1 = stopTime - startTime;
       System.out.println("Time for " + maxLoops + " loops: " + elapsed1 + " milliseconds.");

       aStack = new DWvStack(1000);
       System.out.println("Initialize a stack of 1000 items.");
       maxLoops = 1000;
       startTime = System.currentTimeMillis();
       Integer temp;
       for (int j=0; j<maxLoops; j++) {
          for (int k=0; k<1000; k++) {
             aStack.push( myData[k] );
          }
          while ( !aStack.isEmpty() ) {
             temp = (Integer)aStack.pop();
          }
       }
       stopTime = System.currentTimeMillis();
       long elapsed2 = stopTime - startTime;
       System.out.println("Time for " + maxLoops + " loops: " + elapsed2 + " milliseconds.");
    /*


       System.out.println("Stack size: " + myStack.size());
       for (int k=0; k<5; k++) {
          myData = new Integer(k);
          myStack.push(myData);
          System.out.println("Push: " + (Integer)myStack.peek());
       }
       System.out.println("Stack empty: " + myStack.isEmpty());
       System.out.println("Stack size: " + myStack.size());
       while ( !myStack.isEmpty() ) {
          System.out.println("Pop: " + (Integer)myStack.pop());
       }
       System.out.println("Stack empty: " + myStack.isEmpty());
       System.out.println("Stack size: " + myStack.size());
       myData = (Integer)myStack.pop();
       System.out.println("Pop: " + myData);
  */
    }
   

}
