import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Font;
import java.awt.Color;

public class ColorSwirl extends Applet implements Runnable {

	private static final long serialVersionUID = 1L;
	
	Font theFont = new Font("TimesRoman", Font.BOLD, 48);
	Color colors[] = new Color[50];
	Thread runner;
	
	public void init() {
		// Initialize the color array.
		float c = 0;
		for (int i=0; i<colors.length; i++) {
			colors[i] = Color.getHSBColor(c, 1.0f, 1.0f);
			c += 0.02f;
		}
	}
	
	public void start()	 {
		if (runner == null) {
			runner = new Thread(this);
			runner.start();
		}
	}
	
	public void stop()	{
		if (runner != null) {
			runner = null;
		}
	}

	public void run() {
		// Cycle through the colors
		int i = 0;
		while (true) {
			setForeground(colors[i]);
			repaint();
			i = (i+1)%colors.length;
			try { Thread.sleep(100); }
			catch (InterruptedException e) { }
		}
	}

	public void update(Graphics g) {
		paint(g);
	}
 
 
	public void paint(Graphics g) {
		g.setFont(theFont);
		g.drawString("All the Swirly Colors",15,50);
	}
}