import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Font;
import java.awt.Color;
import java.util.Date;

public class DigitalClock extends Applet implements Runnable {

	private static final long serialVersionUID = 1L;
	
	protected int fontSize;
	protected Font theFont;
	protected Color theColor;
	protected Date theDate;
	protected Thread runner;
	
	public void init() {
		String fontSizeSpec = getParameter("Size");
		if (fontSizeSpec == null) {
			fontSize = 24;
		} else {
			fontSize = Integer.parseInt(fontSizeSpec);
		}
		theFont = new Font("TimesRoman", Font.BOLD, fontSize);
		
		String colorSpec = getParameter("Color");
		if (colorSpec == null) {
			theColor = Color.black;
		} else if (colorSpec.equals("Green")) {
			theColor = Color.green;
		} else if (colorSpec.equals("Blue")) {
			theColor = Color.blue;
		} else if (colorSpec.equals("Orange")) {
			theColor = Color.orange;
		} else if (colorSpec.equals("Cyan")) {
			theColor = Color.cyan;
		} else if (colorSpec.equals("Magenta")) {
			theColor = Color.magenta;
		} else if (colorSpec.equals("Yellow")) {
			theColor = Color.yellow;
		} else {
			theColor = Color.red;
		}
	}
	
	public void start()	 {
		if (runner == null) {
			runner = new Thread(this);
			runner.start();
			}
		}

	public void stop()	{
		if (runner != null) {
			runner = null;
			}
		}

	public void run() {
		while (true) {
			theDate = new Date();
			repaint();
			try { Thread.sleep(1000); }
			catch (InterruptedException e) { }
		}
	}
	
	public void paint(Graphics g) {
		g.setFont(theFont);
		g.setColor(theColor);
		g.drawString(theDate.toString(),25,fontSize);
	}
}