public interface Prioritizeable extends Comparable, Cloneable  {
	
	public boolean higherThan(Prioritizeable obj);
	// Returns true if this object has priority equal to or higher than the
	// specified object.  If the objects are not comparable, then the method
	// may throw a ClassCastException.
	
	public boolean lowerThan(Prioritizeable obj);
	// Returns true if this object has priority strictly lower than the
	// specified object.  If the objects are not comparable, then the method
	// may throw a ClassCastException.
	
	public boolean adjustPriority(Comparable obj);
	// A prioritizable object can have its priority raised or lowered.
	// The method returns true if this object has a priority that is equal
	// to or higher than before.

	public int compareTo(Object obj);
	
	public Object clone();
 
}
