public class StackBenchmark {

	public static void main(String args[]) {

		int maxLoops = 1000;
		int dataSize = 1000;
		if (0 < args.length) {
			dataSize = Integer.parseInt(args[0]);
		}
		if (1 < args.length) {
			maxLoops = Integer.parseInt(args[1]);
		}

		//  Initialize the data objects
		Integer[] myData = new Integer[dataSize];
		for (int k=0; k<dataSize; k++) {
			myData[k] = new Integer(k);
		}
		System.out.println("myData[ " + (dataSize-1) + "] = " + myData[dataSize-1]);			 

		//  Create and initialize a default stack.
		DWvStack aStack;
		System.out.println("Create a default stack.");
		long startTime = System.currentTimeMillis();
		for (int j=0; j<maxLoops; j++) {
			aStack = new DWvStack();
		}
		long stopTime = System.currentTimeMillis();
		long elapsed1 = stopTime - startTime;
		System.out.println("Time for " + maxLoops + " loops: " + elapsed1 + " milliseconds.");

		System.out.println("Create a default stack and fill it with " + dataSize + " items.");
		startTime = System.currentTimeMillis();
		Integer temp;
		for (int j=0; j<maxLoops; j++) {
			aStack = new DWvStack();
			for (int k=0; k<dataSize; k++) {
				aStack.push( myData[k] );
			}
		}
		stopTime = System.currentTimeMillis();
		long elapsed2 = stopTime - startTime;
		System.out.println("Time for " + maxLoops + " loops: " + elapsed2 + " milliseconds.");

		System.out.println("Create a default stack and fill it with " + dataSize + " items,");
		System.out.println("and then empty it.");
		startTime = System.currentTimeMillis();
		for (int j=0; j<maxLoops; j++) {
			aStack = new DWvStack();
			for (int k=0; k<dataSize; k++) {
				aStack.push( myData[k] );
			}
			while ( !aStack.isEmpty() ) {
				temp = (Integer)aStack.pop();
			}
		}
		stopTime = System.currentTimeMillis();
		long elapsed3 = stopTime - startTime;
		System.out.println("Time for " + maxLoops + " loops: " + elapsed3 + " milliseconds.");
	}
}
