import java.util.*;

public class M865Edge implements Comparable {
	protected M865Vertex source;
	protected M865Vertex target;
	
	public M865Edge(M865Vertex source, M865Vertex target) {
		if (0 < source.compareTo(target)) { 
			this.source = target;
			this.target = source;
		} else {
			this.source = source;
			this.target = target;
		}		
	}
	
	public M865Vertex getSource() {
		return source;
	}
	
	public M865Vertex getTarget() {
		return target;
	}
	
	public int compareTo(Object e) {
		if (e instanceof M865Edge) {
			int t = source.compareTo(((M865Edge)e).getSource());
			if (t == 0) {
				t = target.compareTo(((M865Edge)e).getTarget());
			}
			return t;
		} else {
			throw new ClassCastException("Not an edge");
		}
	}

	public boolean equals(Object e) {
		if (e instanceof M865Edge) {
			return (source.equals(((M865Edge)e).getSource()) &&
					  target.equals(((M865Edge)e).getTarget()));
		} else {
			throw new ClassCastException("Not an edge");
		}
	}

	public int hashCode() {
		long hash = (source.hashCode() + target.hashCode()) % Integer.MAX_VALUE;
		return (int)hash;
	}

	public Object clone() {
		return new M865Edge((M865Vertex)source.clone(), (M865Vertex)target.clone());
	}

	public String toString() {
		return "{" + source + ", " + target + "}";
	} 
	
	public static void main(String[] args) {
		M865Edge e = new M865Edge(new M865Vertex("xyz"), new M865Vertex("abc"));
		System.out.println( e );
	} 
}

