/** 
	The MyShape class is an abstract class which defines the fields, methods
    and behavior common to all shapes.
*/

import java.awt.*;

abstract public class MyShape {
	static public final int defaultWidth = 20, defaultHeight = 10;
	static public final Color defaultColor = Color.red;
   
	Color color;
	int x;
	int y;
	int wide;
	int high;

	MyShape(int x, int y, int w, int h, Color c) {
		this.x = x;
		this.y = y;
		this.wide = w;
		this.high = h;
		this.color = c;
	}
	
	void moveTo(int x, int y) {
		this.x = x;
		this.y = y;
	}
	
	abstract void draw(Graphics g);

	abstract float area();

	abstract float perimeter();
	
	public String toString() {
		String myInfo;
		myInfo = "at (" + x + "," + y + "), ";
		myInfo += wide + " pixels wide, " + high + " pixels high.\n";
		myInfo += color;
		return( myInfo );
	}
}

